/*global window client module require*/
(function(){"use strict";
	var util = client.require('util'),
	    User = require('../User'),
	    Class = client.require('core').require('Class'),
	    Widget = client.require('Widget');
	module.exports = Class.create('UserList', Widget, function (obj, supr, klass) {
		obj.newOptions().config({
			id: 'userlist', names: 'user list'
		});
		obj.initUserList = function (user) {
			if (!User.check(user)) throw 'Invalid User object.';
			return this.initWidget(this.user = user);
		};
		obj.load = function (cb) {
			return supr.load.call(this, function () {
				this.users = [];
				util.ajax('user/list', function (success, json) {
					var content = success && JSON.parse(json);
					if (content && content.success) {
						this.users = content.users;
					}
					util.safeApply(cb, this);
				}, this);
				util.safeApply(cb, this);
			});
		};
		obj.render = function () {
			return supr.render.call(this, function (dom) {
				this.config({parent: this.app.dom.root});
			});
		};
		obj.redraw = function () {
			return supr.redraw.call(this, function (dom) {
				var html = [];
				util.enumerate(this.users, function (user) {
					html.push(user.username);
				});
				dom.root.innerHTML = '<a>' + html.join('</a><br/><a>') + '</a>';
			});
		};
	});
}).call(this);