/*global window document client module require*/
(function(){"use strict";
	var util = client.require('util'),
	    User = require('../User'),
	    Class = client.require('core').require('Class'),
	    Widget = client.require('Widget');
	module.exports = Class.create('UserLogin', Widget, function (obj, supr, klass) {
		obj.newOptions().config({
			id: 'login', names: 'login'
		});
		obj.initUserLogin = function (user) {
			if (!User.check(user)) throw 'Invalid User object.';
			return this.initWidget(this.user = user);
		};
		obj.render = function () {
			return supr.render.call(this, function (dom) {
				dom.form = dom.root.firstChild;
				dom.credentials = dom.form.firstChild;
				dom.errors = dom.form.childNodes[1];
				dom.cancel = dom.form.lastChild;
				dom.root.appendChild(dom.form);
				this.config({parent: this.app.dom.root});
			});
		};
		obj.redraw = function () {
			return supr.redraw.call(this, function (dom) {
				if (this.user.isNotGuest()) {
					dom.cancel.style.display = '';
				} else {
					dom.cancel.style.display = 'none';
				}
			});
		};
		obj.submit = function (cb) {
			var errors = this.dom.errors;
			errors.innerHTML = '';
			errors.style.display = 'none';
			util.ajax('user/login', function (success, json, xhr) {
				try {
					json = JSON.parse(json);
					success = success && json.success;
				} catch (err) {
					success = false;
					json.error = err;
				}
				if (success) {
					this.user.setSession(json.session);
					util.safeApply(cb, this);
					this.hide();
					this.app.goTo('#/');
				} else {
					errors.innerHTML = json.error;
					errors.style.display = '';
				}
			}, this, {
				method: 'post',
				data: util.dom.formJSON(this.dom.form)
			});
			return this;
		};
		obj.show = function () {
			if (this.isShowing) return this;
			this.isShowing = true;
			this.redraw();
			this.user.signup.hide();
			this.dom.root.style.display = '';
			return this;
		};
		obj.hide = function () {
			if (!this.isShowing) return this;
			delete this.isShowing;
			this.dom.root.style.display = 'none';
			return this;
		};
	});
}).call(this);