/*global window client module require*/
(function(){"use strict";
	var util = client.require('util'),
	    User = require('../User'),
	    Class = client.require('core').require('Class'),
	    Widget = client.require('Widget');
	module.exports = Class.create('UserMenu', Widget, function (obj, supr, klass) {
		obj.newOptions().config({
			html: ([
				'Welcome <span></span><br/>',
				'<a href="#/">Home</a>',
				'<a href="#/user/logout">Logout</a>',
				'<a href="#/user/login">Change User</a>',
				'<a href="#/user/signup">Create User</a>',
				'<a href="#/user/remove" style="display:none;">Delete User</a>'
			]).join(''),
			names: 'user menu'
		});
		obj.initUserMenu = function (user) {
			if (!User.check(user)) throw 'Invalid User object.';
			return this.initWidget(this.user = user);
		};
		obj.render = function () {
			return supr.render.call(this, function (dom) {
				dom.username = dom.root.childNodes[1];
				dom.remove = dom.root.lastChild;
				this.config({parent: this.app.menu.dom.root});
			});
		};
		obj.redraw = function () {
			return supr.redraw.call(this, function (dom) {
				this.dom.username.innerHTML =
					this.user.data && this.user.data.username || 'guest';
				if (this.user.isNotGuest()) {
					dom.remove.style.display = '';
				} else {
					dom.remove.style.display = 'none';
				}
			});
		};
	});
}).call(this);