var Model = require('app/lib/Model'),
    Crypto = require('ezcrypto').Crypto;
new Model('User').install(module, function () {
	this.hashPassword = function (user, rawPassword) {
		return c.HMAC(c.SHA256, user.username, rawPassword);
	};
	this.matchPassword = function (user, data) {
		return user && data && user.password === data.password;
	};
	this.login = function (data, cb) {
		return this.find(data.user.username, function (err, user) {
			if (!err && this.matchPassword(user, data.user)) {
				cb.call(this, null, user);
			} else cb(err);
		});
	};
	this.signup = function (data, cb) {
		if (data.confirmPassword !== data.user.password) {
			cb.call(this, 'Password confirmation failed.');
			return this;
		}
		return this.find(data.user.username, function (err, user) {
			if (!err && !user) {
				var that = this;
				user = new this.model(data.user);
				user.save(function (err) {
					if (err) cb.call(that, err);
					else cb.call(that, null, user);
				});
			} else {
				if (!err) err = 'User already exists.';
				cb.call(this, err);
			}
		});
	};
	return new this.Schema({
		username: {type: String, unique: true},
		password: String,
		created: Date,
		logged: Date
	});
});